diff -ur zabbix-1.8.5/configure zabbix-1.8.5-zones/configure
--- zabbix-1.8.5/configure	Fri Apr 15 15:18:33 2011
+++ zabbix-1.8.5-zones/configure	Tue Aug  2 15:56:31 2011
@@ -5315,7 +5315,140 @@
 fi
 LIBS="${LIBS} ${RESOLV_LIBS}"
 
+if test "${ac_cv_header_zone_h+set}" = set; then
+  { echo "$as_me:$LINENO: checking for zone.h" >&5
+echo $ECHO_N "checking for zone.h... $ECHO_C" >&6; }
+if test "${ac_cv_header_zone_h+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_header_zone_h" >&5
+echo "${ECHO_T}$ac_cv_header_zone_h" >&6; }
+else
+  # Is the header compilable?
+{ echo "$as_me:$LINENO: checking zone.h usability" >&5
+echo $ECHO_N "checking zone.h usability... $ECHO_C" >&6; }
+cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+$ac_includes_default
+#include <zone.h>
+_ACEOF
+rm -f conftest.$ac_objext
+if { (ac_try="$ac_compile"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_compile") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && {
+	 test -z "$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       } && test -s conftest.$ac_objext; then
+  ac_header_compiler=yes
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
 
+	ac_header_compiler=no
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+{ echo "$as_me:$LINENO: result: $ac_header_compiler" >&5
+echo "${ECHO_T}$ac_header_compiler" >&6; }
+
+# Is the header present?
+{ echo "$as_me:$LINENO: checking zone.h presence" >&5
+echo $ECHO_N "checking zone.h presence... $ECHO_C" >&6; }
+cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+#include <zone.h>
+_ACEOF
+if { (ac_try="$ac_cpp conftest.$ac_ext"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_cpp conftest.$ac_ext") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } >/dev/null && {
+	 test -z "$ac_c_preproc_warn_flag$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       }; then
+  ac_header_preproc=yes
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+  ac_header_preproc=no
+fi
+
+rm -f conftest.err conftest.$ac_ext
+{ echo "$as_me:$LINENO: result: $ac_header_preproc" >&5
+echo "${ECHO_T}$ac_header_preproc" >&6; }
+
+# So?  What about this header?
+case $ac_header_compiler:$ac_header_preproc:$ac_c_preproc_warn_flag in
+  yes:no: )
+    { echo "$as_me:$LINENO: WARNING: zone.h: accepted by the compiler, rejected by the preprocessor!" >&5
+echo "$as_me: WARNING: zone.h: accepted by the compiler, rejected by the preprocessor!" >&2;}
+    { echo "$as_me:$LINENO: WARNING: zone.h: proceeding with the compiler's result" >&5
+echo "$as_me: WARNING: zone.h: proceeding with the compiler's result" >&2;}
+    ac_header_preproc=yes
+    ;;
+  no:yes:* )
+    { echo "$as_me:$LINENO: WARNING: zone.h: present but cannot be compiled" >&5
+echo "$as_me: WARNING: zone.h: present but cannot be compiled" >&2;}
+    { echo "$as_me:$LINENO: WARNING: zone.h:     check for missing prerequisite headers?" >&5
+echo "$as_me: WARNING: zone.h:     check for missing prerequisite headers?" >&2;}
+    { echo "$as_me:$LINENO: WARNING: zone.h: see the Autoconf documentation" >&5
+echo "$as_me: WARNING: zone.h: see the Autoconf documentation" >&2;}
+    { echo "$as_me:$LINENO: WARNING: zone.h:     section \"Present But Cannot Be Compiled\"" >&5
+echo "$as_me: WARNING: zone.h:     section \"Present But Cannot Be Compiled\"" >&2;}
+    { echo "$as_me:$LINENO: WARNING: zone.h: proceeding with the preprocessor's result" >&5
+echo "$as_me: WARNING: zone.h: proceeding with the preprocessor's result" >&2;}
+    { echo "$as_me:$LINENO: WARNING: zone.h: in the future, the compiler will take precedence" >&5
+echo "$as_me: WARNING: zone.h: in the future, the compiler will take precedence" >&2;}
+
+    ;;
+esac
+{ echo "$as_me:$LINENO: checking for zone.h" >&5
+echo $ECHO_N "checking for zone.h... $ECHO_C" >&6; }
+if test "${ac_cv_header_zone_h+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  ac_cv_header_zone_h=$ac_header_preproc
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_header_zone_h" >&5
+echo "${ECHO_T}$ac_cv_header_zone_h" >&6; }
+
+fi
+if test $ac_cv_header_zone_h = yes; then
+
+cat >>confdefs.h <<\_ACEOF
+#define HAVE_ZONE_H 1
+_ACEOF
+
+fi
+
+
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for an ANSI C-conforming const" >&5
 $as_echo_n "checking for an ANSI C-conforming const... " >&6; }
 if test "${ac_cv_c_const+set}" = set; then :
@@ -10197,7 +10330,7 @@
 found_iconv="no"
 
 	{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for ICONV support" >&5
-$as_echo_n "checking for ICONV support... " >&6; }
+$as_echo_n "checking for local ICONV support... " >&6; }
 
 	if test -f /usr/include/iconv.h; then
 		found_iconv="yes"
diff -ur zabbix-1.8.5/configure.in zabbix-1.8.5-zones/configure.in
--- zabbix-1.8.5/configure.in	Fri Apr 15 15:17:32 2011
+++ zabbix-1.8.5-zones/configure.in	Tue Aug  2 14:48:49 2011
@@ -61,6 +61,7 @@
   stdarg.h winsock2.h pdh.h psapi.h sys/sem.h sys/ipc.h sys/shm.h Winldap.h \
   sys/timeb.h Winber.h lber.h ws2tcpip.h inttypes.h sys/file.h grp.h \
   execinfo.h libperfstat.h sys/systemcfg.h sys/times.h)
+AC_CHECK_HEADER(zone.h, [AC_DEFINE([HAVE_ZONE_H], 1, [Define to 1 if you have the 'zone.h'])])
 AC_CHECK_HEADERS(resolv.h, [], [], [
   #ifdef HAVE_SYS_TYPES_H
   #  include <sys/types.h>
diff -ur zabbix-1.8.5/include/config.h.in zabbix-1.8.5-zones/include/config.h.in
--- zabbix-1.8.5/include/config.h.in	Fri Apr 15 15:18:33 2011
+++ zabbix-1.8.5-zones/include/config.h.in	Tue Aug  2 14:50:11 2011
@@ -39,6 +39,9 @@
 /* Define to 1 if you have the <fcntl.h> header file. */
 #undef HAVE_FCNTL_H
 
+/* Define to 1 if you have the <zone.h> header file. */
+#undef HAVE_ZONE_H
+
 /* Define to 1 if function 'curl_easy_escape' exists. */
 #undef HAVE_FUNCTION_CURL_EASY_ESCAPE
 
diff -ur zabbix-1.8.5/include/sysinc.h zabbix-1.8.5-zones/include/sysinc.h
--- zabbix-1.8.5/include/sysinc.h	Fri Apr 15 15:17:28 2011
+++ zabbix-1.8.5-zones/include/sysinc.h	Tue Aug  2 14:52:45 2011
@@ -424,4 +424,8 @@
 #	include <fcntl.h>
 #endif
 
+#ifdef HAVE_ZONE_H
+#	include <zone.h>
+#endif
+
 #endif
diff -ur zabbix-1.8.5/src/libs/zbxsysinfo/solaris/proc.c zabbix-1.8.5-zones/src/libs/zbxsysinfo/solaris/proc.c
--- zabbix-1.8.5/src/libs/zbxsysinfo/solaris/proc.c	Fri Apr 15 15:17:29 2011
+++ zabbix-1.8.5-zones/src/libs/zbxsysinfo/solaris/proc.c	Tue Aug  2 15:04:04 2011
@@ -175,8 +175,15 @@
 	int		fd = -1;
 	int		zbx_proc_stat;
 	zbx_uint64_t	proccount = 0;
+#if defined(HAVE_ZONE_H)
+	char		zonename[MAX_STRING_LEN];
+	zoneid_t	zoneid;
 
+	if (num_param(param) > 5)
+#else
+
 	if (num_param(param) > 4)
+#endif
 		return SYSINFO_RET_FAIL;
 
 	if (0 != get_param(param, 1, procname, sizeof(procname)))
@@ -216,6 +223,16 @@
 	if (0 != get_param(param, 4, proccomm, sizeof(proccomm)))
 		*proccomm = '\0';
 
+#if defined(HAVE_ZONE_H)
+	if (0 != get_param(param, 5, zonename, sizeof(zonename)))
+		*zonename='\0';
+	if (*zonename != '\0') {
+		zoneid = getzoneidbyname(zonename);
+		if (0 > zoneid)
+			return SYSINFO_RET_FAIL;
+	}
+
+#endif
 	if (NULL == (dir = opendir("/proc")))
 		return SYSINFO_RET_FAIL;
 
@@ -249,7 +266,10 @@
 
 		if ('\0' != *proccomm && NULL == zbx_regexp_match(psinfo.pr_psargs, proccomm, NULL))
 			continue;
-
+#if defined(HAVE_ZONE_H)
+		if ('\0' != *zonename && zoneid != psinfo.pr_zoneid)
+			continue;
+#endif
 		proccount++;
 	}