Index: include/locales/en_gb.inc.php
===================================================================
--- include/locales/en_gb.inc.php	(revision 27175)
+++ include/locales/en_gb.inc.php	(working copy)
@@ -23,12 +23,12 @@
 
 	$TRANSLATION = array(
 
-	'S_YEAR_SHORT'=>			_('y'),
-	'S_MONTH_SHORT'=>			_('m'),
-	'S_WEEK_SHORT'=>			_('w'),
-	'S_DAY_SHORT'=>				_('d'),
-	'S_HOUR_SHORT' =>			_('h'),
-	'S_MINUTE_SHORT' =>			_('m'),
+	'S_YEAR_SHORT'=>			_x('y', 'year short'),
+	'S_MONTH_SHORT'=>			_x('m', 'month short'),
+	'S_WEEK_SHORT'=>			_x('w', 'week short'),
+	'S_DAY_SHORT'=>				_x('d', 'day short'),
+	'S_HOUR_SHORT' =>			_x('h', 'hour short'),
+	'S_MINUTE_SHORT' =>			_x('m', 'minute short'),
 
 //	exp_imp.php
 	'S_ELEMENT'=>				_('Element'),
@@ -150,6 +150,7 @@
 	'S_CHARTBAR_HOURLY_DATE_FORMAT'=>		_('Y.m.d H:i'),
 	'S_CHARTBAR_DAILY_DATE_FORMAT'=>		_('Y.m.d'),
 	'S_IT_NOTIFICATIONS'=>			_('Notification report'),
+	// GETTEXT: Date format (year). Do not translate.
 	'S_REPORT4_ANNUALLY_DATE_FORMAT'=>	_('Y'),
 	'S_REPORT4_MONTHLY_DATE_FORMAT'=>	_('M Y'),
 	'S_REPORT4_DAILY_DATE_FORMAT'=>		_('d M Y'),
@@ -194,13 +195,13 @@
 	'S_NO_ELEMENTS_SELECTED'=>	_('No elements selected!'),
 
 //	class.calendar.js
-	'S_MONDAY_SHORT_BIG'=>		_('M'),
-	'S_TUESDAY_SHORT_BIG'=>		_('T'),
-	'S_WEDNESDAY_SHORT_BIG'=>	_('W'),
-	'S_THURSDAY_SHORT_BIG'=>	_('T'),
-	'S_FRIDAY_SHORT_BIG'=>		_('F'),
-	'S_SATURDAY_SHORT_BIG'=>	_('S'),
-	'S_SUNDAY_SHORT_BIG'=>		_('S'),
+	'S_MONDAY_SHORT_BIG'=>		_x('M', 'Monday short'),
+	'S_TUESDAY_SHORT_BIG'=>		_x('T', 'Tuesday short'),
+	'S_WEDNESDAY_SHORT_BIG'=>	_x('W', 'Wednesdy short'),
+	'S_THURSDAY_SHORT_BIG'=>	_x('T', 'Thursday short'),
+	'S_FRIDAY_SHORT_BIG'=>		_x('F', 'Friday short'),
+	'S_SATURDAY_SHORT_BIG'=>	_x('S', 'Saturday short'),
+	'S_SUNDAY_SHORT_BIG'=>		_x('S', 'Sunday short'),
 	'S_NOW'=>	_('Now'),
 	'S_DONE'=>	_('Done'),
 
Index: include/func.inc.php
===================================================================
--- include/func.inc.php	(revision 27175)
+++ include/func.inc.php	(working copy)
@@ -384,14 +384,14 @@
 }
 
 function mem2str($size) {
-	$prefix = _('B');
+	$prefix = _x('B', 'Byte short');
 	if ($size > 1048576) {
 		$size = $size / 1048576;
-		$prefix = _('M');
+		$prefix = _x('M', 'Mega short');
 	}
 	elseif ($size > 1024) {
 		$size = $size / 1024;
-		$prefix = _('K');
+		$prefix = _x('K', 'Kilo short');
 	}
 	return round($size, 6).$prefix;
 }
@@ -423,7 +423,7 @@
 
 function convertUnitsS($value) {
 	if (floor(abs($value) * 1000) == 0) {
-		$value = ($value == 0) ? '0'._('s') : '< 1'._('ms');
+		$value = ($value == 0) ? '0'._x('s', 'second short') : '< 1'._x('ms', 'millisecond short');
 		return $value;
 	}
 
@@ -437,7 +437,7 @@
 	$n_unit = 0;
 
 	if (($n = floor($secs / SEC_PER_YEAR)) != 0) {
-		$value .= $n._('y').' ';
+		$value .= $n._x('y', 'year short').' ';
 		$secs -= $n * SEC_PER_YEAR;
 		if (0 == $n_unit) {
 			$n_unit = 4;
@@ -445,7 +445,7 @@
 	}
 
 	if (($n = floor($secs / SEC_PER_MONTH)) != 0) {
-		$value .= $n._('m').' ';
+		$value .= $n._x('m', 'month short').' ';
 		$secs -= $n * SEC_PER_MONTH;
 		if (0 == $n_unit) {
 			$n_unit = 3;
@@ -453,7 +453,7 @@
 	}
 
 	if (($n = floor($secs / SEC_PER_DAY)) != 0) {
-		$value .= $n._('d').' ';
+		$value .= $n._x('d', 'day short').' ';
 		$secs -= $n * SEC_PER_DAY;
 		if (0 == $n_unit) {
 			$n_unit = 2;
@@ -461,7 +461,7 @@
 	}
 
 	if ($n_unit < 4 && ($n = floor($secs / SEC_PER_HOUR)) != 0) {
-		$value .= $n._('h').' ';
+		$value .= $n._x('h', 'hour short').' ';
 		$secs -= $n * SEC_PER_HOUR;
 		if (0 == $n_unit) {
 			$n_unit = 1;
@@ -469,17 +469,17 @@
 	}
 
 	if ($n_unit < 3 && ($n = floor($secs / SEC_PER_MIN)) != 0) {
-		$value .= $n._('m').' ';
+		$value .= $n._x('m', 'minute short').' ';
 		$secs -= $n * SEC_PER_MIN;
 	}
 
 	if ($n_unit < 2 && ($n = floor($secs)) != 0) {
-		$value .= $n._('s').' ';
+		$value .= $n._x('s', 'second short').' ';
 		$secs -= $n;
 	}
 
 	if ($n_unit < 1 && ($n = round($secs * 1000)) != 0) {
-		$value .= $n._('ms');
+		$value .= $n._x('ms', 'millisecond short');
 	}
 
 	return rtrim($value);
@@ -542,17 +542,17 @@
 
 	if (!isset($digitUnits[$step])) {
 		$digitUnits[$step] = array(
-			array('pow' => -2, 'short' => _('µ'), 'long' => _('Micro')),
-			array('pow' => -1, 'short' => _('m'), 'long' => _('Milli')),
+			array('pow' => -2, 'short' => _x('µ', 'Micro short'), 'long' => _('Micro')),
+			array('pow' => -1, 'short' => _x('m', 'Milli short'), 'long' => _('Milli')),
 			array('pow' => 0, 'short' => '', 'long' => ''),
-			array('pow' => 1, 'short' => _('K'), 'long' => _('Kilo')),
-			array('pow' => 2, 'short' => _('M'), 'long' => _('Mega')),
-			array('pow' => 3, 'short' => _('G'), 'long' => _('Giga')),
-			array('pow' => 4, 'short' => _('T'), 'long' => _('Tera')),
-			array('pow' => 5, 'short' => _('P'), 'long' => _('Peta')),
-			array('pow' => 6, 'short' => _('E'), 'long' => _('Exa')),
-			array('pow' => 7, 'short' => _('Z'), 'long' => _('Zetta')),
-			array('pow' => 8, 'short' => _('Y'), 'long' => _('Yotta'))
+			array('pow' => 1, 'short' => _x('K', 'Kilo short'), 'long' => _('Kilo')),
+			array('pow' => 2, 'short' => _x('M', 'Mega short'), 'long' => _('Mega')),
+			array('pow' => 3, 'short' => _x('G', 'Giga short'), 'long' => _('Giga')),
+			array('pow' => 4, 'short' => _x('T', 'Tera short'), 'long' => _('Tera')),
+			array('pow' => 5, 'short' => _x('P', 'Peta short'), 'long' => _('Peta')),
+			array('pow' => 6, 'short' => _x('E', 'Exa short'), 'long' => _('Exa')),
+			array('pow' => 7, 'short' => _x('Z', 'Zetta short'), 'long' => _('Zetta')),
+			array('pow' => 8, 'short' => _x('Y', 'Yotta short'), 'long' => _('Yotta'))
 		);
 
 		foreach ($digitUnits[$step] as $dunit => $data) {
@@ -1528,7 +1528,7 @@
 	$table = BR();
 	if ($cnt_pages > 1) {
 		if ($startPage > 1) {
-			$pagespan = new CSpan('<< '._('First'), 'darklink');
+			$pagespan = new CSpan('<< '._x('First', 'page navigation'), 'darklink');
 			$pagespan->setAttribute('onclick', 'javascript: openPage(0);');
 
 			$pageline[] = $pagespan;
@@ -1536,7 +1536,7 @@
 		}
 
 		if ($crnt_page > 1) {
-			$pagespan = new CSpan('< '._('Previous'), 'darklink');
+			$pagespan = new CSpan('< '._x('Previous', 'page navigation'), 'darklink');
 			$pagespan->setAttribute('onclick', 'javascript: openPage('.(($crnt_page - 2) * $rows_per_page).');');
 
 			$pageline[] = $pagespan;
@@ -1563,7 +1563,7 @@
 		array_pop($pageline);
 
 		if ($crnt_page < $cnt_pages) {
-			$pagespan = new CSpan(_('Next').' >', 'darklink');
+			$pagespan = new CSpan(_x('Next', 'page navigation').' >', 'darklink');
 			$pagespan->setAttribute('onclick', 'javascript: openPage('.($crnt_page * $rows_per_page).');');
 
 			$pageline[] = ' | ';
@@ -1571,7 +1571,7 @@
 		}
 
 		if ($p < $cnt_pages) {
-			$pagespan = new CSpan(_('Last').' >>', 'darklink');
+			$pagespan = new CSpan(_x('Last', 'page navigation').' >>', 'darklink');
 			$pagespan->setAttribute('onclick', 'javascript: openPage('.(($cnt_pages - 1) * $rows_per_page).');');
 
 			$pageline[] = '&nbsp;&nbsp;';
Index: include/blocks.inc.php
===================================================================
--- include/blocks.inc.php	(revision 27175)
+++ include/blocks.inc.php	(working copy)
@@ -1006,8 +1006,8 @@
 	$header = array(
 		is_show_all_nodes() ? new CCol(_('Node'), 'center') : null,
 		new CCol(_('Discovery rule'), 'center'),
-		new CCol(_('Up')),
-		new CCol(_('Down'))
+		new CCol(_x('Up', 'discovery results in dashboard')),
+		new CCol(_x('Down', 'discovery results in dashboard'))
 	);
 
 	$table  = new CTableInfo();
Index: include/classes/class.cserverinfo.php
===================================================================
--- include/classes/class.cserverinfo.php	(revision 27175)
+++ include/classes/class.cserverinfo.php	(working copy)
@@ -40,7 +40,7 @@
 			: _('Zabbix server');
 
 		$this->addRow(new CCol(_('Zabbix server info'), 'nowrap ui-corner-all ui-widget-header'));
-		$this->addRow(_('Updated').': '.zbx_date2str(_('r'), time())); // GETTEXT: r is date format string as described in http://php.net/date
+		$this->addRow(_('Updated').': '.zbx_date2str(_('D, d M Y H:i:s O'), time()));
 		$this->addRow(_('Users (online)').': '.$status['users_count'].'('.$status['users_online'].')');
 		$this->addRow(new CCol(array(_('Logged in as').SPACE, new CLink(CWebUser::$data['alias'], 'profile.php'))));
 		$this->addRow(new CCol(array($serverLink, SPACE._('is').SPACE, $server)), 'status');
Index: include/views/configuration.maintenance.list.php
===================================================================
--- include/views/configuration.maintenance.list.php	(revision 27175)
+++ include/views/configuration.maintenance.list.php	(working copy)
@@ -52,13 +52,13 @@
 
 	switch ($maintenance['status']) {
 		case MAINTENANCE_STATUS_EXPIRED:
-			$maintenanceStatus = new CSpan(_('Expired'), 'red');
+			$maintenanceStatus = new CSpan(_x('Expired', 'maintenance status'), 'red');
 			break;
 		case MAINTENANCE_STATUS_APPROACH:
-			$maintenanceStatus = new CSpan(_('Approaching'), 'blue');
+			$maintenanceStatus = new CSpan(_x('Approaching', 'maintenance status'), 'blue');
 			break;
 		case MAINTENANCE_STATUS_ACTIVE:
-			$maintenanceStatus = new CSpan(_('Active'), 'green');
+			$maintenanceStatus = new CSpan(_x('Active', 'maintenance status'), 'green');
 			break;
 	}
 
Index: include/discovery.inc.php
===================================================================
--- include/discovery.inc.php	(revision 27175)
+++ include/discovery.inc.php	(working copy)
@@ -146,8 +146,8 @@
 
 function discovery_object_status2str($status = null) {
 	$discoveryStatus = array(
-		DOBJECT_STATUS_UP => _('Up'),
-		DOBJECT_STATUS_DOWN => _('Down'),
+		DOBJECT_STATUS_UP => _x('Up', 'discovery status'),
+		DOBJECT_STATUS_DOWN => _x('Down', 'discovery status'),
 		DOBJECT_STATUS_DISCOVER => _('Discovered'),
 		DOBJECT_STATUS_LOST => _('Lost')
 	);
Index: latest.php
===================================================================
--- latest.php	(revision 27175)
+++ latest.php	(working copy)
@@ -197,7 +197,7 @@
 		make_sorting_header(_('Name'), 'i.name'),
 		make_sorting_header(_('Last check'), 'i.lastclock'),
 		_('Last value'),
-		_('Change'),
+		_x('Change', 'noun in latest data'),
 		_('History')
 	));
 